{$X+,B-,V-}
program SendHello;

{ Simple IPX demonstration program with 1 ESR.}

uses crt,nwMisc,nwIPX;

CONST IOSocket=$5678;

Var NewStack   :array[1..4096] of word; { !! used by ESR }
    StackBottom:word;                  { !! used by ESR }

    SendEcb    :Tecb;
    IpxHdr     :TipxHeader;
    socket     :word;
    dest       :TinternetworkAddress;
    buf        :array[1..546] of byte;
    t          :byte;
    w          :word;
    s          :string;
    PacketSent :boolean;
{$F+}
Procedure SendESR; forward;
procedure WaitESR; Forward;

Procedure SendESRhandler(Var p:Tpecb);
begin
inc (w);
{str(w:4,s);
move(s[1],p^.fragment[2].address^,4);}
p^.esraddress:=Addr(WaitESR);
IPXsendPacket(p^);
end;

Procedure WaitESRHandler(Var p:Tpecb);
begin
PacketSent:=true;
p^.esrAddress:=Addr(SendESR);
IPXscheduleIPXevent(20*18,p^);
end;

Procedure SendESR; assembler;
asm { ES:SI are the only valid registers when entering this procedure ! }
    mov dx, seg stackbottom
    mov ds, dx

    mov dx,ss  { setup of a new local stack }
    mov bx,sp  { ss:sp copied to dx:bx}
    mov ax,ds
    mov ss,ax
    mov sp,offset stackbottom
    push dx    { push old ss:sp on new stack }
    push bx

    push es    { push es:si on stack as local vars }
    push si
    mov  di,sp

    push ss    { push address of local ptr on stack }
    push di
    CALL SendEsrHandler

    add sp,4   { skip stack ptr-copy }
    pop bx     { restore ss:sp from new stack }
    pop dx
    mov sp,bx
    mov ss,dx
end;


Procedure WaitESR; assembler;
asm { ES:SI are the only valid registers when entering this procedure ! }
    mov dx, seg stackbottom
    mov ds, dx

    mov dx,ss  { setup of a new local stack }
    mov bx,sp  { ss:sp copied to dx:bx}
    mov ax,ds
    mov ss,ax
    mov sp,offset stackbottom
    push dx    { push old ss:sp on new stack }
    push bx

    push es    { push es:si on stack as local vars }
    push si
    mov  di,sp

    push ss    { push address of local ptr on stack }
    push di
    CALL WaitEsrHandler

    add sp,4   { skip stack ptr-copy }
    pop bx     { restore ss:sp from new stack }
    pop dx
    mov sp,bx
    mov ss,dx
end;
{$F-}

begin
IF NOT IpxInitialize
 then begin
      writeln('Ipx needs to be installed.');
      halt(1);
      end;
socket:=IOSocket;
IF NOT IPXopenSocket(Socket,SHORT_LIVED_SOCKET)
 then begin
      writeln('IPXopenSocket returned error# ',nwIPX.result);
      halt(1);
      end;

for t:=1 to 4 do dest.net[t]:=$00; { this net / segment }
for t:=1 to 6 do dest.node[t]:=$FF; { all nodes }
dest.socket:=IOsocket;

w:=1;
{ Fill buffer (ECB.fragment[2]^) }
str(w:4,s);
s:=s+' IPX: Hello World';
FillChar(buf,546,#0);
move(s[1],buf,ord(s[0]));

{ setup ECB and IPX header }
PacketSent:=False;
IPXsetupSendECB(Addr(WaitESR),dest,@buf,ord(s[0]),
                IpxHdr,SendEcb);
IPXsendPacket(SendEcb);

REPEAT

IpxRelinquishControl;

IF PacketSent
 then begin
      writeln('IPX packet #',w-1:0,' was sent.');
      PacketSent:=false;
      end;

UNTIL Keypressed;


IF NOT IPXcloseSocket(IOsocket)
then writeln('IPXcloseSocket returned error# ',nwIPX.result);

end.
